

;													
; PWM SCHALTNETZTEIL fr ATmega8					
; Bernhard.Erfurt@gmx.de							
; 04/2006											
;													
; Bei 16 MHz C TAkt arbeitet das Schaltnetzteil 	
; mit einer Frequenz von ca. 40 kHz					
;													

; Anschlussbelegung PINS						
;												
; PB0 ==> PWM AUSGANG							
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
; PC6 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 										


; ATmega8 										
.include "m8def.inc"


; PINS											
.equ PWM_B		=0

; REGISTER										
.def PWM	= R9	; PWM-WERT 						  	
.def PWM_MAX= R10	; FREQUENZ / Periodendauer der PWM	
.def temp 	= R16	; TEMP								



.cseg					;Beginn eines Code-Segmentes	  
.org 0					;Startadresse=0					  
; Interrupt-Vektoren fr ATmega8						  
rjmp RESET      ; Reset Handler                           
reti ;rjmp EXT_INT0   ; IRQ0 Handler                      
reti ;rjmp EXT_INT1   ; IRQ1 Handler                      
reti ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
reti ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
reti ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
reti ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
reti ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
reti ;rjmp TIM1_OVF   	  ; Timer1 Overflow Handler       
reti ;rjmp TIM0_OVF   ; Timer0 Overflow Handler           
reti ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
reti ;rjmp ZEICHEN_EINLESEN ; USART RX Complete Handler   
reti ;rjmp USART_UDRE ; UDR Empty Handler                 
reti ;rjmp USART_TXC  ; USART TX Complete Handler         
reti ;rjmp ADC        ; ADC Conversion Complete Handler   
reti ;rjmp EE_RDY     ; EEPROM Ready Handler              
reti ;rjmp ANA_COMP   ; Analog Comparator Handler         
reti ;rjmp TWSI       ; Two-wire Serial Interface Handler 
reti ;rjmp SPM_RDY    ; Store Program Memory Ready Handler

RESET:                        
;STACK initialisieren
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

; PORT B initialisieren			
	ldi temp, 0b11111111
	out DDRB, temp
; PORT B setzen					
	andi temp,0b11111110		; BITMUSTER (einige auf LOW)
	out PORTB, temp				; alle Ausgnge auf HIGH	
; PORT C initialisieren			
	ldi temp, 0b11111111
	out DDRC, temp
; PORT C setzen					
	out PORTC, temp				; alle Ausgnge auf HIGH	
; PORT D initialisieren			
	ldi temp, 0b11111111
	out DDRD, temp
; PORT D setzen					
	out PORTD, temp				; alle Ausgnge auf HIGH	

;Watchdog aktivieren (max. Zeit)
ldi TEMP,(1<<WDCE)|(1<<WDE)  
out wdtcr,TEMP       
ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
out wdtcr,temp

; STARTWERTE					

ldi temp, 100		; VOREINSTELLUNG PWM-MAX
mov PWM_MAX, temp

ldi temp, 5			; VOREINSTELLUNG PWM	
mov PWM, temp


; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	wdr							; Watch-DOG-RESET	
	clr temp					; TEMP lschen		
	sbi PORTB, PWM_B			; PWM-PIN-HIGH		
;---------------
LOOP_ww:
	inc temp					; temp +1			
	cp temp,PWM 				; vergleich PWM		
	brlo LOOP_ww				; TEMP kleiner als PWM => SPRUNG
	cbi PORTB, PWM_B			; PWM-PIN-LOW		
;---------------
LOOP_www:
	inc temp					; +1				
	cp  temp, PWM_MAX			; vergleich PWM_MAX	
	brlo LOOP_www 				; TEMP kleiner als PWM_MAX => SPRUNG

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################